
\documentclass[a4paper, 11pt]{article}
\usepackage[top=3cm, bottom=3cm, left = 2cm, right = 2cm]{geometry} 
\geometry{a4paper} 
\usepackage[utf8]{inputenc}
\usepackage{textcomp}
\usepackage{graphicx} 
\usepackage{amsmath,amssymb}  
\usepackage{bm}  
\usepackage[pdftex,bookmarks,colorlinks,breaklinks]{hyperref}  
%\hypersetup{linkcolor=black,citecolor=black,filecolor=black,urlcolor=black} % black links, for printed output
\usepackage{memhfixc} 
\usepackage{pdfsync}  
\usepackage{fancyhdr}
\usepackage[natbib=true,
            style=numeric,
            sorting=none
            ]{biblatex}
\addbibresource{references.bib}
\pagestyle{fancy}

\title{Activty Report}
\author{Mohamed Aymane KHERRAZ}
%\date{}

\begin{document}
\maketitle
\tableofcontents

\section{Introduction}

This file hold a log of activity over time.

\pagebreak

\section{Exploring GNNs}

\subsection{Reviewing Research Papers}
\textbf{Date: 26/10/2023}
\textbf{Time: 6 hours 0 minutes}

The recent exploration of research papers proved to be an intellectually stimulating endeavor. The papers 
covered a spectrum of difficulty levels. The first paper \cite{gap}, was notably accessible, providing valuable insights with straightforward 
mathematical formulations. Conversely, grappling with the mathematical concepts and notions presented 
in the paper \cite{gnn_survey} and \cite{ml_on_graphs} posed a substantial challenge.


\subsection{Getting Started with the PyG}
\textbf{Date: 9/11/2023}
\textbf{Time: 5 hours 30 minutes (10:30 AM to 4:00 PM)}

I started working with the PyG Library, setting up my environment and dealing with compatibility issues. 
The PyG documentation was helpful, but I faced a bit of a struggle in the Message Passing section. 
However, with persistence, I eventually grasped the mathematical concepts.


\subsection{Exploring GNN Projects}
\subsubsection{Initiation to GNN project}
\textbf{Date: 16/11/2023}
\textbf{Time: 5 hours 30 minutes (9:00 AM to 12:00 PM ; 4:00 PM to 6:30 PM)}

The journey into GNN projects started by carefully reading the PyTorch Geometric documentation \cite{pyg_design}, going up 
to the part about how to use it. But because it got too detailed, we decided to switch to simpler 
articles. Unfortunately, these articles didn't have practical examples, making it hard to grasp PyG's 
details. Realizing we needed hands-on practice, we started coding.

While exploring, we found a helpful guide on Graph Convolutional Networks. This guide made understanding 
the formulas in both PyTorch Geometric and the paper \cite{gcn_guide} 
much easier. With this knowledge, we began working on a GNN project. Interestingly, we noticed that 
defining models in PyTorch Geometric was quite similar to PyTorch, but there were a few small differences 
and complexities that we handled with a practical approach.


\subsubsection{Finishing the initiation and moving to the node classification}
\textbf{Date: 22/11/2023}
\textbf{Time: 2 hours 0 minutes (1:30 PM to 3:30 PM)}

Almost half of the duration was used to understand a few problems in the initiating GNN like the goal of 
the algorithm and check every small step in the algorithm.
Once this step was done i started working on a "node classification" and "graph classification" algorithm.


\subsubsection{Finishing node classification}
\textbf{Date: 23/11/2023}
\textbf{Time: 4 hours 30 minutes (1:30 PM to 6:00 PM)}

I resumed my work on the "node classification" algorithm.
I spent some time to understand the Multi-layer perceptron network (MLP), but I didn't understand it's 
role in this project perfectly, so I quickly moved to the GNN because they said that the only difference is to switch the 
\emph{torch.nn.Linear}~\eqref{eq:linear_equation} layer to a \emph{GCNConv}~\eqref{eq:gcnconv_equation}.

\begin{equation}\label{eq:linear_equation}
\mathbf{x}_v^{(\ell + 1)} = \mathbf{W}^{(\ell + 1)} \mathbf{x}_v^{(\ell)}
\end{equation}

\begin{equation}\label{eq:gcnconv_equation}
\mathbf{x}_v^{(\ell + 1)} = \mathbf{W}^{(\ell + 1)} \sum_{w \in \mathcal{N}(v) \, \cup \, \{ v \}} \frac{1}{c_{w,v}} \cdot \mathbf{x}_w^{(\ell)}
\end{equation}

where $\mathbf{W}^{(\ell + 1)}$ represents a trainable weight matrix of shape 
$`[num\_output\_features, num\_input\_features]$, and $c\_{w,v}$ refers to a fixed normalization coefficient for 
each edge.

I understood what the GNN does and how it works relatively easily.
(This experience reinforced the fact that writing an algorithm in PyTorch is very similar to PyG).\linebreak

This part exausted me so i put that work on hold and worked on the activity report by adding references 
to articles and websites to make it easier for my supervisors to follow up with my progress.\linebreak

After the pseudo-break i continued working on the "node classification" project. I understood a very 
valuable information in this project. Using \emph{torch.nn.Linear} does lead to $0.5900$ accuraccy and $0.3810$ loss
which isn't that bad. However by simply switching to \emph{GCNConv} that make great use of the graph structure and 
node neighboors we jump to $0.8150$ accuracy and $0.5799$ loss.
The exercice at the end was a bit of a challenge because it included another model that i have never seen
which is the Graph Attention Network \emph{GATConv}.

\subsubsection{Finishing graph classification and W\&B application}
\textbf{Date: 24/11/2023}
\textbf{Time: 3 hours 0 minutes (12:30 PM to 3:30 PM)}

The graph classification algorithm was done with close to no difficulty. I noticed that there was 
another variation of the two algorithms with Weights \& Biases (W\&B) so i decided to check it out 
and see what W\&B was used for in this case. I didn't give the understanding of the code a lot of 
importance. I moved quickly to the output that was provided and saw a lot of information that might be 
helpfull in fine tuning the model and getting the best of it. And also knowing what to change to improve 
it and which way to do so (this could be used to improve the RL model that i would use for graph 
partinioning). Sadly i coudln't run the W\&B with graph classification because my computer couldn't 
handle it (I spent a lot of time trying to debug the given code because the versions of modules weren't 
compatible).
The last bit of time was used to learn a bit more about GNNs and Non-Euclidean domains.

\section{Explanatory meeting.}
\textbf{Date: 30/11/2023}
\textbf{Time: 3 hours 0 minutes (3:00 PM to 6:00 PM)}

The goal of that day was to update my instructers about what i have managed to do and what could be done 
to get us closer to the solution of graph partitioning.

\begin{itemize}
    \item Update README, which presents the different tutorials in a few words.
    \item Update README with Google Colab links.
    \item Update README to explain what needs to be done to test a tutorial on a Debian machine.
    \item Create some slides to explain the Cora tutorial for a meeting in January.
    \item The slides should include a general intro on different approaches with GNN -> to take a step back.
    \item Explore the spectral approach, particularly with SSGConv: what is it used for? And a small tutorial if it's relevant for the graph partitioning problem.
    \item See how reinforcement learning is done on PyTorch and then on PyG.
    \item A small demo that explains MLP with PyTorch and makes a comparison with GNN in PyG.
    \item Find a demo that solves a problem like the shortest path to hope to apply it to our problem.
    \item (for personal development) Review the theory behind convolution in GNN and understand its role.
\end{itemize}

\subsection{Working on the meeting objectives}
\textbf{Date: 14/12/2023}
\textbf{Time: 4 hours 30 minutes (8:30 AM to 1:00 PM)}

Adding google collab links in the read me for easy code running and adding project description.
Started working on directions on how to run the code on a local machine using miniconda.

\subsection{Working on the meeting objectives}
\textbf{Date: 14/12/2023}
\textbf{Time: 3 hours 30 minutes ( 3:00 PM to 6:30 PM)}

Fixing problems found while making the miniconda tutorial and finishing README.

\subsection{Working on the meeting objectives}
\textbf{Date: 18/12/2023}
\textbf{Time: 2 hours 0 minutes ( 4:30 PM to 6:30 PM)}

\subsection{Working on the meeting objectives}
\textbf{Date: 19/12/2023}
\textbf{Time: 5 hours 30 minutes ( 1:00 PM to 6:30 PM)}

Trying different layers and spectral with theoritical understanding. Use of W\&B for 
potential improvements in the performance of the GNN algorithm.

\subsection{Working on the meeting objectives}
\textbf{Date: 20/12/2023}
\textbf{Time: 1 hours 30 minutes ( 8:30 AM to 10:00 AM)}

\subsection{Working on the meeting objectives}
\textbf{Date: 21/12/2023}
\textbf{Time: 2 hours 30 minutes ( 2:00 PM to 4:30 PM)}

\subsection{Working on the meeting objectives}
\textbf{Date: 22/12/2023}
\textbf{Time: 2 hours 30 minutes ( 2:00 PM to 6:30 PM)}

Learning about reinforced learning with Pytorch and starting the development of a state and reward 
class using Gym library.

\subsection{Initiation of RL with PyG}
\textbf{Date: 16/01/2024}
\textbf{Time: 2 hours 30 minutes}

Developed the initial version of the environment code using the Gym library and created an example utilizing a dumbbell graph.

\subsection{Starting PyG slides}
\textbf{Date: 19/01/2024}
\textbf{Time: 6 hours 0 minutes}

Creating the initial version of the code accompanied by diagrams and comments for the working group (WG). Commencing the slides with a description of the Cora dataset.

\subsection{Adding more description to code and slides}
\textbf{Date: 22/01/2024}
\textbf{Time: 4 hours 0 minutes}

Enhancing the slides and Jupyter code by incorporating MLP and GNN structures for improved clarity. Introducing 
the initial version of code descriptions and highlights. Illustrating the challenges in non-Euclidean space through 
graphs and their corresponding computational representations.

\subsection{Adding more description to code and slides}
\textbf{Date: 24/01/2024}
\textbf{Time: 4 hours 0 minutes}

Incorporate computation graph and GNN mathematics in relation to GCNConv. Enhance the WG slides by including additional descriptive images and slides.

\subsection{Review meeting on WG slides and code}
\textbf{Date: 25/01/2024}
\textbf{Time: 6 hours 0 minutes}

Meeting with the teachers to discuss the work that was done on the subject of node classification.

\subsection{Adding math formulas to the slides}
\textbf{Date: 29/01/2024}
\textbf{Time: 3 hours 0 minutes}

Working on the slides and code for the WG.\\

Let \( H^{(1)} \) and \( H^{(2)} \) be the hidden layer representations in a neural network with two layers. The activation functions are denoted by \( \sigma \). The weight matrices are \( W^{(0)} \) and \( W^{(1)} \), and the input features are represented by \( H^{(0)} \).

The propagation from the input layer \( H^{(0)} \) to the first hidden layer \( H^{(1)} \) is given by:
\[
H^{(1)} = \sigma(\tilde{D}^{-\frac{1}{2}} \tilde{A} \tilde{D}^{-\frac{1}{2}} H^{(0)}W^{(0)})
\]

Where:
\begin{itemize}
    \item \( \tilde{D}^{-\frac{1}{2}} \tilde{A} \tilde{D}^{-\frac{1}{2}} \) represents a matrix operation with dimensions \( (nume\_nodes, num\_nodes) \).
    \item \( H^{(0)} \) is the input matrix with dimensions \( (nume\_nodes, num\_features) \).
    \item \( W^{(0)} \) is the weight matrix connecting the input layer to the first hidden layer with dimensions \( (nume\_features, num\_hidden\_features) \).
\end{itemize}

Similarly, the propagation from the first hidden layer \( H^{(1)} \) to the second hidden layer \( H^{(2)} \) is given by:
\[
H^{(2)} = \sigma(\tilde{D}^{-\frac{1}{2}} \tilde{A} \tilde{D}^{-\frac{1}{2}} H^{(1)}W^{(1)})
\]

Where:
\begin{itemize}
    \item \( \tilde{D}^{-\frac{1}{2}} \tilde{A} \tilde{D}^{-\frac{1}{2}} \) remains the same matrix operation with dimensions \( (nume\_nodes, num\_nodes) \).
    \item \( H^{(1)} \) is the hidden layer matrix with dimensions \( (nume\_nodes, num\_hidden\_features) \).
    \item \( W^{(1)} \) is the weight matrix connecting the first hidden layer to the second hidden layer with dimensions \( (num\_hidden\_features, num\_hidden\_features) \).
\end{itemize}


$$\mathbf{x}_i^{(k)} = \gamma^{(k)} \left( \mathbf{x}_i^{(k-1)}, \bigoplus_{j \in \mathcal{N}(i)} \, \phi^{(k)}\left(\mathbf{x}_i^{(k-1)}, \mathbf{x}_j^{(k-1)},\mathbf{e}_{j,i}\right) \right),$$

Where:
\begin{itemize}
    \item $\mathbf{x}^{(k-1)}_i \in \mathbb{R}^{num\_features}$ denoting node features of node $i$ in layer $(k-1)$ and $\mathbf{e}_{j,i} \in \mathbb{R}^{edge\_features}$ denoting (optional) edge features from node $j$ to node $i$.
    \item $\bigoplus$ denotes a differentiable, permutation invariant function, e.g., sum, mean or max.
    \item $\gamma$ and $\phi$ denote differentiable functions such as MLPs (Multi Layer Perceptrons).
\end{itemize}

\subsection{Adding math formulas to the slides}
\textbf{Date: 31/01/2024}
\textbf{Time: 2 hours 30 minutes}

Organising slides on google docs.

\section{Presenting WG}
\textbf{Date: 06/02/2024}
\textbf{Time: 1 hours 30 minutes}

Presenting the seminar or PyG and GNNs.

\section{Starting work on RL}
\textbf{Date: 12/02/2024}
\textbf{Time: 4 hours 30 minutes}

Trying ALice Gati code and trying to fix Metis wrapper problem.

\section{Starting work on RL}
\textbf{Date: 22/02/2024}
\textbf{Time: 4 hours 00 minutes}

Fixed Metis wrapper and started looking at training and coreset graph training.

\section{Adding slides to DE}
\textbf{Date: 14/03/2024}
\textbf{Time: 4 hours 30 minutes}

Doing research on the subjects discussed in the paper of ALice Gati like advantage actor critic (A2C) and the different layers and technologies used (ex: graph coarsening).

\section{Adding slides to DE}
\textbf{Date: 20/03/2024}
\textbf{Time: 4 hours 00 minutes}

Adding GNN slides and A2C explanatory 
Adding Minimal edge separator slides.

\section{Adding slides to DE}
\textbf{Date: 28/03/2024}
\textbf{Time: 6 hours 00 minutes}

Adding graphs and results of the research study and details of reinforced learning process.
Explanation of reinforced learning model and layers.

\section{Reviewing drl partitioning code}
\textbf{Date: 08/04/2024}
\textbf{Time: 5 hours 00 minutes}

Fixed the problem of import of metis library because miniconda doesn't work correctly with the made solution.
Started reviewing code for better understanding of the reinforced learning model.

\section{First attempts at testing reinforced model}
\textbf{Date: 15/04/2024}
\textbf{Time: 4 hours 30 minutes}

100 to 10K nodes for all graphs.
Training the drl and metis\_drl models (+ 2 hours) with the normalized cut function.
The reward is the gain in the normalized cut.
First few results of drl, drl\_metis, metis, scotch partitioning libraries. (+ 1 hour)

\section{Generating perfs for partinioning models with NC}
\textbf{Date: 18/04/2024}
\textbf{Time: 5 hours 00 minutes}

Using the log file of test to generate perfs using an R script.
(Results are decent but let's test by changing only the reward for the gain of NC to the gain of balanced NC)
Training (+ 2 hours) testing (+ 1 hour). Made a mistake by forgeting to change the gain in the calculations of metis reward (+ 1 hour) testing.

\section{Comparing NC and balanced NC}
\textbf{Date: 22/04/2024}
\textbf{Time: 5 hours 00 minutes}

The NC gives decent results but the balance isn't so good so we use the balanced normalized cut as described in \cite{gap}.
Trying to add needed modules to plafrim to train on the HPC computers of INRIA.
(Adding them to the shared module space isn't allowed. That leads to trying to add them on the local machine [On-going].)

% \section{Starting to work on the report of DE.}
% \textbf{Date: 29/04/2024}
% \textbf{Time: 0 hours 00 minutes}

% \section{X}
% \textbf{Date: X}
% \textbf{Time: X hours X minutes}

\pagebreak
\printbibliography
\end{document}

